local tbgui =
{
  type="frame_style",
  parent="frame_style",
  graphical_set=
  {
    type = "monolith",
    top_monolith_border = 1,
    right_monolith_border = 1,
    bottom_monolith_border = 1,
    left_monolith_border = 1,
    monolith_image =
    {
      filename = "__TimeButtons__/resources/GUI/50x120.png",
      width = 120,
      height = 50,
      x = 0,
      y = 0
    }
  }
}

local time_button=
    {
      type = "button_style",
      font = "default-button",
      --minimal_width = 880,
      --minimal_height = 440,
	  hovered_font_color = {r=0, g=0, b=0},
      default_font_color={r=1, g=1, b=1},
      align = "center",
      top_padding = 5,
      right_padding = 5,
      bottom_padding = 5,
      left_padding = 5,
      default_graphical_set =
      {
        type = "composition",
        filename = "__TimeButtons__/resources/GUI/gui.png",
        corner_size = {3, 3},
        position = {0, 0}
      },
      hovered_font_color={r=1, g=1, b=1},
      hovered_graphical_set =
      {
        type = "composition",
        filename = "__TimeButtons__/resources/GUI/gui.png",
        corner_size = {3, 3},
        position = {0, 8}
      },
      clicked_font_color={r=1, g=1, b=1},
      clicked_graphical_set =
      {
        type = "composition",
        filename = "__TimeButtons__/resources/GUI/gui.png",
        corner_size = {3, 3},
        position = {0, 16}
      },
      pie_progress_color = {r=1, g=1, b=1}
    }


local tb_textfield_style=
    {
      type = "textfield_style",
      left_padding = 3,
      right_padding = 2,
      minimal_width = 50,
      maximal_width = 50,
      font = "default",
      font_color = {},
	  align = "center",
      graphical_set =
      {
        type = "composition",
        filename = "__core__/graphics/gui.png",
        corner_size = {3, 3},
        position = {16, 0}
      },
      selection_background_color= {r=0.66, g=0.7, b=0.83}
    }





data.raw["gui-style"].default["tb_textfield_style"] = tb_textfield_style
data.raw["gui-style"].default["tbgui"] = tbgui
data.raw["gui-style"].default["time_button"] = time_button
